/** @file
 * @brief SerializeServiceContainer class header. This class holds Service objects in a list for serialization.
 *
 *
 *
 * @copyright Intra2net AG
 * @license GPLv2
*/

#ifndef SERIALIZESERVICECONTAINER_H
#define SERIALIZESERVICECONTAINER_H

#include <list>

#include "service.h"
#include "logger.h"

#include <boost/serialization/array.hpp>
#include <boost/shared_ptr.hpp>

class SerializeServiceContainer
{

private:

    std::list<Service::Ptr> ContainingServices;

    friend class boost::serialization::access;
    template<class Archive>
    void serialize(Archive & ar, const unsigned int version);

public:

    typedef boost::shared_ptr<SerializeServiceContainer> Ptr;

    SerializeServiceContainer();

    ~SerializeServiceContainer();

    void add_service(Service::Ptr service);

    std::list<Service::Ptr> get_containing_services() const;

};

#endif
